#include <stdio.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <malloc.h>
#include <errno.h>
#include <unistd.h>

#include "mlm_file.h"
#include "mlm_string.h"



/*Local Variables*/
struct dirent **namelist;
char **movie_namelist;

extern listed;


/*Functions*/

/*****************************************************************/

void opening_control(void)
{
    FILE *conf1; //Kişinin girdiği son dizinin kayıt edileceği dosya
    char *main_index_dir, *main_conf_dir, *main_info_dir, *conf1_path;
    main_dir =       (char *)calloc(50, sizeof(char));
    main_conf_dir =  (char *)calloc(60, sizeof(char));
    main_index_dir = (char *)calloc(60, sizeof(char));
    main_info_dir  = (char *)calloc(60, sizeof(char));

    username = getenv("LOGNAME");
    sprintf(main_dir, "/home/%s/.movielist manager", username);

    sprintf(main_conf_dir, "%s/conf", main_dir);
    sprintf(main_index_dir, "%s/index", main_dir);
    sprintf(download_index_path, "%s/index.html", main_index_dir);
    sprintf(main_info_dir, "%s/info", main_dir);


    if(access(main_dir, 0)) {
        printf("Ana dizin bulunamadı, oluşturulacak.\n");

        if(mkdir(main_dir, 0777) != 0) {
         printf("Ana dizin oluşturulurken bir hata meydana geldi...\n");
         exit(EXIT_FAILURE);
        }

        if(mkdir(main_index_dir, 0777) != 0) {
         printf("index dizini oluşturulurken bir hata meydana geldi...\n");
         exit(EXIT_FAILURE);
        }

        if(mkdir(main_conf_dir, 0777) != 0) {
         printf("conf dizini oluşturulurken bir hata meydana geldi...\n");
         exit(EXIT_FAILURE);
        }

        if(mkdir(main_info_dir, 0777) != 0) {
         printf("info dizini oluşturulurken bir hata meydana geldi...\n");
         exit(EXIT_FAILURE);
        }

        sprintf(moviespath, "/home/%s", username);
        conf1_path = calloc(80, sizeof(char));
        sprintf(conf1_path, "%s/conf1", main_conf_dir);

        if((conf1 = fopen(conf1_path, "w")) == NULL){
            fprintf(stdout, "%s dosyası açılamadı\n", conf1_path);
            exit(EXIT_FAILURE);
        }
        fprintf(conf1, "%s\n", moviespath);

    }
    else {
        conf1_path = calloc(80, sizeof(char));
        sprintf(conf1_path, "%s/conf1", main_conf_dir);

        if((conf1 = fopen(conf1_path, "r")) == NULL){
                fprintf(stdout, "%s dosyası açılamadı\n", conf1_path);
                exit(EXIT_FAILURE);
        }
        printf("************************************\n");
        fgets(moviespath, 250, conf1);
        remove_lastchar(moviespath);
        system("rm ~/\".movielist manager\"/index/*");
    }

    free(conf1_path);
    free(main_conf_dir);
    free(main_index_dir);
    free(main_info_dir);

}

/*****************************************************************/

 char *get_moviename(int movieno) {

    return movie_namelist[movieno];

}

/*****************************************************************/

 int scan_files(void)
{

	if(listed == 1){
		int i;
	    for(i = 0; i != n; ++i){
	    	free(movie_namelist[i]);
	    }

	    free(movie_namelist);
	}
    n = scandir(moviespath, &namelist, 0, alphasort);

    if (n == -1)
        return -1;

    return n;
}

/*****************************************************************/

 void save_movieslist(void)
{
    int i, k;


    movie_namelist = (char **)calloc(n, sizeof(char *));

    for(i = 0; i != n; ++i)
    	movie_namelist[i] = (char *)calloc(100, sizeof(char));


    i = 1;
    for (k = 0; k != n; k++) {
        if (!strcmp(namelist[k]->d_name, ".") || !strcmp(namelist[k]->d_name, "..")) {
            free(namelist[k]);
            continue;
        }
        strcpy(movie_namelist[i], namelist[k]->d_name);
        ++i;
        free(namelist[k]);
    }
}

/*****************************************************************/

 void print_movieslist(void)
{
    int i;

    for (i = 1; i < n - 1; i++)
        printf("%d) %s\n", i, movie_namelist[i]);

}

/*****************************************************************/

void f_printhtml(FILE *f, char *dest)
{
    int i;
    
    char trchar[] = "ABCÇDEFGĞHIİJKLMNOÖPRSŞTUÜVYZabcçdefgğhıijklmnoöprsştuüvyz',-0123456789.;:?! \n";


    str_insert_all(dest, "&rsquo;", "'");
    str_insert_all(dest, "&ldquo;", "\"");
    str_insert_all(dest, "&rdquo;", "\"");
    str_insert_all(dest, "\t", "");

    for (i = 0; dest[i] != '\0'; i++) {

        if (dest[i] == '<')
            while(1)
                if (dest[++i] == '>') {
                    i++;
                    break;
                }

        if (strchr(trchar, dest[i]))
            fputc(dest[i], f);
    }

}

/*****************************************************************/

 void rename_movie(int movieno, char *newname)
{
    char movie_oldname[250];
    char movie_newname[250];
    char *movieinfo_dir, *movieinfo_newdir;

    sprintf(movie_oldname, "%s/%s", moviespath, movie_namelist[movieno]);
    sprintf(movie_newname, "%s/%s", moviespath, newname);
    rename(movie_oldname, movie_newname);

    //Varsa film bilgilerinin ismini de değiştir
    movieinfo_dir = (char *)calloc(160, sizeof(char));
    sprintf(movieinfo_dir,"%s/info/%s", main_dir, movie_namelist[movieno]);
	if(!(access(movieinfo_dir, 0))){
	    movieinfo_newdir  = (char *)calloc(160, sizeof(char));
	    sprintf(movieinfo_newdir,"%s/info/%s", main_dir, newname);
	    rename(movieinfo_dir, movieinfo_newdir);
	}
}
/*****************************************************************/

 void delete_movie(int movieno)
{
    char moviepath[250], *movieinfo_dir;

    /// Filmin kendisi siliniyor
    sprintf(moviepath, "%s/%s", moviespath, movie_namelist[movieno]);

    //errno ayarlanıyor... Eğer silme işleminden sonra errno 39'a ayarlanırsa moviepath içi dolu bir dizindir.
    errno = 0;
    remove(moviepath);

    if(errno == 39){
       	sprintf(moviepath,"rm -R '%s/%s'",moviespath, movie_namelist[movieno] ); // moviepath dizin silmek için komut olarak kullanılıyor
       	system(moviepath);
    }

    //Varsa film bilgilerini de sil
    movieinfo_dir = (char *)calloc(160, sizeof(char));
    sprintf(movieinfo_dir,"%s/info/%s", main_dir, movie_namelist[movieno]);
	if(!(access(movieinfo_dir, 0))){
		errno = 0;
		remove(movieinfo_dir);
	    if(errno == 39){
	       	sprintf(movieinfo_dir,"rm -R '%s/info/%s'", main_dir, movie_namelist[movieno]);
	       	system(movieinfo_dir);

	    }
	}

}
/*****************************************************************/

 int scan_save_movieinfo_dir(char movie_infodir_content[2][200], char *movieinfo_dir)
{
    int file_count;
    struct dirent **namelist;
    file_count = scandir(movieinfo_dir, &namelist, 0, alphasort);

    if(file_count == -1){
            fprintf(stdout, "Dizin bulunamadı:%s\n", movieinfo_dir);
            return;
    }
    while (file_count--) {
        if (!strcmp(namelist[file_count]->d_name, ".") || !strcmp(namelist[file_count]->d_name, "..")) {
            free(namelist[file_count]);
            continue;
        }

        if(!strcmp(namelist[file_count]->d_name, "info")){
            sprintf(movie_infodir_content[0], "%s/%s", movieinfo_dir, namelist[file_count]->d_name);
            sprintf(movie_infodir_content[1], "%s/%s", movieinfo_dir, namelist[file_count-1]->d_name);
            free(namelist[file_count]);
            free(namelist[(file_count-1)]);
            break;
        }
        else {
            sprintf(movie_infodir_content[1], "%s/%s", movieinfo_dir, namelist[file_count]->d_name);
            sprintf(movie_infodir_content[0], "%s/%s", movieinfo_dir, namelist[file_count-1]->d_name);
            free(namelist[file_count]);
            free(namelist[(file_count-1)]);
            break;
        }
    }

}

/*****************************************************************/

 char *read_all_file(const char *info_dir)
{
	FILE *infofile;
	char *file_path, *file_content;
	int k, i;

	file_path = (char *)calloc(200, sizeof(char));
	sprintf(file_path, "%s/info", info_dir);

	if((infofile = fopen(file_path, "r")) == NULL){
		fprintf(stdout, "%s dosyası açılamadı\n", file_path);
		free(file_path);
		return NULL;
	}

	file_content = (char *)calloc(5000, sizeof(char));

	i = 0;
	while((k = fgetc(infofile)) != EOF){
		file_content[i] = k;
		++i;
	}

	file_content[i] = '\0';
	return file_content;
}

/*****************************************************************/

 int get_movieno(char *moviename) {
    int movie_no;

    for(movie_no = 1; movie_no < (n - 2); ++movie_no){
    	if(!strcmp(movie_namelist[movie_no], moviename))
    		break;
    }
    return movie_no;

}

/*****************************************************************/

 void remove_movieinfo(const char *movie_name)
{
	char *movieinfo_dir;

    movieinfo_dir = (char *)calloc(160, sizeof(char));
    sprintf(movieinfo_dir,"%s/info/%s", main_dir, movie_name);
		errno = 0;
		remove(movieinfo_dir);
	    if(errno == 39){
	       	sprintf(movieinfo_dir,"rm -R '%s/info/%s'", main_dir, movie_name);
	       	system(movieinfo_dir);

	    }
}

/*****************************************************************/

 char * compare_moviespath_maininfodir_files(const char *main_info_dir, char other_movies[200][100])
{
	struct dirent **infolist;
	int file_count,i, j;
	int find = 0;

	i = 1;
	j = 1;


	file_count = scandir(main_info_dir, &infolist, 0, alphasort);

	while (file_count--) {
        if (!strcmp(infolist[file_count]->d_name, ".") || !strcmp(infolist[file_count]->d_name, "..")) {
            free(infolist[file_count]);
            continue;
        }

        for (; i <= (n - 2); ++i) {
        	if(!(strcmp(infolist[file_count] -> d_name, movie_namelist[i])))
        		find = 1;
        }

    	if(find == 0){
    		strcpy(other_movies[j], infolist[file_count] -> d_name);
    		++j;
    	}
		find = 0;
    	i = 1;
    	free(infolist[file_count]);
	}

	///free memory for movie_namelist
    for(i = 0; i != n; ++i){
    	free(movie_namelist[i]);
    }

    free(movie_namelist);


    //get memory for movie_list
    movie_namelist = (char **)calloc(j, sizeof(char *));

    for(i = 0; i != j; ++i)
    	movie_namelist[i] = (char *)calloc(100, sizeof(char));


    for (i = 1; i < j ; ++i)
    	strcpy(movie_namelist[i], other_movies[i]);
	n = i;

	return (char*)other_movies;
}

