#include <gtk/gtk.h>
#include <malloc.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include "mlm_gui.h"
#include "mlm_file.h"
#include "mlm_download.h"
#include "mlm_utility.h"
#include "mlm_string.h"


#define ICON_PATH "/usr/share/mlm/images/afis.jpg"

static void fill_movielist_properties( GtkWidget *widget, gpointer data );
static void call_remove_info(GtkMenuItem *item, gpointer movie_name);

GtkWidget *main_window, *main_hbox, *file_chooser, *sw_textview, *movies_list, *show_movie_sum, *hpaned, *search_entry, *show_other_infos, *point_label, *show_movie_cast, *vbox2, *movies_icon_list, *show_all, *show_other_infos, *imdb_point, *label_name, *label_director, *label_place, *label_year, *label_type;

///mlm_file.h movie list, show in iconview
extern char **movie_namelist;

char *key;
int listed = 0; //if 1; moviespath is listed


//for GtkListStore
enum
{
  COL_DISPLAY_NAME,
  COL_PIXBUF,
  NUM_COLS
};

/*****************************************************************/

void ask_to_save_info(char *movie_name)
{
    char *movieinfo_dir, *text, *movie_sum, *labels_text;
    char movie_info_poster[2][200];
    GtkWidget  *sw, *hbox, *hbox2,  *vbox, *separator,  *movie_icon, *label, *textview, *imdb_point, *label_director, *label_place, *label_year, *label_type, *point_label;
    GtkTextBuffer *text_buffer, *text_buffer2;
    GtkDialog *saveinfo_dialog;

    movieinfo_dir  = (char *)calloc(250, sizeof(char));
    sprintf(movieinfo_dir, "%s/info/%s", main_dir, movie_name);

    scan_save_movieinfo_dir(movie_info_poster, movieinfo_dir);

    saveinfo_dialog = gtk_dialog_new_with_buttons(
				"",
				GTK_WINDOW(main_window),
				GTK_DIALOG_DESTROY_WITH_PARENT,
				"Bilgileri Sil",
				GTK_RESPONSE_REJECT,
				"Bilgileri Sakla",
				GTK_RESPONSE_ACCEPT,
				NULL);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(saveinfo_dialog -> vbox), hbox);

    if(!(access(movie_info_poster[1], 0)))
        movie_icon = gtk_image_new_from_file(movie_info_poster[1]);
    else
        movie_icon = gtk_image_new_from_file(ICON_PATH);

    gtk_box_pack_start(GTK_BOX(hbox), GTK_WIDGET(movie_icon), FALSE, FALSE, 0);

    separator = gtk_vseparator_new();
    gtk_box_pack_start(GTK_BOX(hbox), separator, FALSE, FALSE, 10);

    vbox = gtk_vbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 0);

    movie_sum = read_all_file(movieinfo_dir);
    labels_text = (char *)calloc(250, sizeof(char));

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);

    text = strstr_dup(movie_sum, "[+mlm_Yıl]", "[-mlm_Yıl]");
    sprintf(labels_text, "Yapım Yılı: %s", text);
    free(text);
    label_year = gtk_label_new(labels_text);
    gtk_box_pack_start(GTK_BOX(hbox2), label_year, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);

    text = strstr_dup(movie_sum, "[+mlm_Yer]", "[-mlm_Yer]");
    sprintf(labels_text, "Yapım Yeri: %s", text);
    free(text);
    label_place = gtk_label_new(labels_text);
    gtk_box_pack_start(GTK_BOX(hbox2), label_place, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);

    text = strstr_dup(movie_sum, "[+mlm_Tur]", "[-mlm_Tur]");
    sprintf(labels_text, "Tür: %s", text);
    free(text);
    label_type = gtk_label_new(labels_text);
    gtk_box_pack_start(GTK_BOX(hbox2), label_type, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);

    text = strstr_dup(movie_sum, "[+mlm_Yonetmen]", "[-mlm_Yonetmen]");
    sprintf(labels_text, "Yönetmen: %s", text);
    free(text);
    label_director = gtk_label_new(labels_text);
    gtk_box_pack_start(GTK_BOX(hbox2), label_director, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);

    text = strstr_dup(movie_sum, "[+mlm_puan]", "[-mlm_puan]");
    sprintf(labels_text, "\nSinemalar.com Puanı: %s", text);
    free(text);
    point_label = gtk_label_new(labels_text);
    gtk_box_pack_start(GTK_BOX(hbox2), point_label, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);

    text = strstr_dup(movie_sum, "[+mlm_IMDB]", "[-mlm_IMDB]");
    sprintf(labels_text, "IMDB Puanı: %s\n", text);
    free(text);
    imdb_point = gtk_label_new(labels_text);
    gtk_box_pack_start(GTK_BOX(hbox2), imdb_point, FALSE, FALSE, 0);

    separator = gtk_vseparator_new();
    gtk_box_pack_start(GTK_BOX(hbox), separator, FALSE, FALSE, 10);

    vbox = gtk_vbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 0);

    char *markup = g_markup_printf_escaped("<span weight=\"bold\">%s</span>", "Oyuncular                   ");
    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label), markup);
    gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);

    sw = gtk_scrolled_window_new(NULL, NULL);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_IN);
    gtk_box_pack_start(GTK_BOX(vbox), sw, TRUE, TRUE, 0);

    text = strstr_dup(movie_sum, "[+mlm_Oyuncular]\n","[-mlm_Oyuncular]");
    text_buffer = gtk_text_buffer_new(NULL);
    gtk_text_buffer_set_text(text_buffer, (gchar *)text, strlen(text));
    free(text);

    textview = gtk_text_view_new_with_buffer(text_buffer);
    gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW(textview), GTK_WRAP_WORD);
    gtk_container_add(GTK_CONTAINER(sw), textview);

    separator = gtk_vseparator_new();
    gtk_box_pack_start(GTK_BOX(hbox), separator, FALSE, FALSE, 10);

    vbox = gtk_vbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 0);

    markup = g_markup_printf_escaped("<span weight=\"bold\">%s</span>", "Özet                                                                  ");
    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label), markup);
    gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);

    sw = gtk_scrolled_window_new(NULL, NULL);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_IN);
    gtk_box_pack_start(GTK_BOX(vbox), sw, TRUE, TRUE, 0);

    text = strstr_dup(movie_sum, "[+mlm_Filmin özeti]\n","[-mlm_Filmin özeti]");
    text_buffer2 = gtk_text_buffer_new(NULL);
    gtk_text_buffer_set_text(text_buffer2, (gchar *)text, -1);
    free(text);

    textview = gtk_text_view_new_with_buffer(text_buffer2);
    gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW(textview), GTK_WRAP_WORD);
    gtk_container_add(GTK_CONTAINER(sw), textview);


    sprintf(labels_text, "%s", movie_name);
    gtk_window_set_title(GTK_WINDOW (saveinfo_dialog), labels_text);
    gtk_widget_show_all(GTK_WIDGET(saveinfo_dialog));



    if((gtk_dialog_run(saveinfo_dialog)) == GTK_RESPONSE_REJECT)
        remove_movieinfo(movie_name);

    g_object_unref(text_buffer);
    g_object_unref(text_buffer2);

    gtk_widget_destroy(GTK_WIDGET(saveinfo_dialog));
    free(movieinfo_dir);
    free(movie_sum);
}

/*****************************************************************/

static void call_moviesearch(GtkMenuItem *item, char * movie_name)
{
    int control;
    char command[250];

    sprintf(command, "/usr/share/mlm/dialog/mlm_show_dialog \"%s Filmi indiriliyor...\nLÜTFEN BEKKLEYİN!!!\"&", movie_name);
    system(command);
    if((control = moviesearch((char *)movie_name)))
        fprint_movieinf(get_movieno((char*) movie_name));

    kill_process();

    if(control)
    	ask_to_save_info(movie_name);

    //if moviespath listed before call_moviesearch then list again, else don't
    if(listed)
    	fill_movielist_properties(NULL, NULL);
}

/*****************************************************************/

static void get_new_movieinfo(GtkMenuItem *item, char * movie_name)
{
    GtkDialog *newmovie_dialog;
    GtkWidget *newmovie_entry, *label;

	newmovie_dialog = gtk_dialog_new_with_buttons(
			"Yeni Film Bilgisi İndirme",
			GTK_WINDOW(main_window),
			GTK_DIALOG_DESTROY_WITH_PARENT,
			"Vazgeç",
			GTK_RESPONSE_REJECT,
			"İndir",
			GTK_RESPONSE_ACCEPT,
			NULL);

	gtk_window_set_default_size(GTK_WINDOW(newmovie_dialog), 300, 150);

	label = gtk_label_new("Bilgileri İndirilecek Filmin Adı");
	gtk_box_pack_start(GTK_BOX(newmovie_dialog -> vbox), label, FALSE, FALSE, 0);

	newmovie_entry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(newmovie_dialog ->vbox), newmovie_entry, FALSE, FALSE, 10);
	gtk_entry_set_max_length (GTK_ENTRY(newmovie_entry), 100);

	gtk_widget_show_all(GTK_WIDGET(newmovie_dialog));

	if((gtk_dialog_run(newmovie_dialog)) == GTK_RESPONSE_ACCEPT){
		char *movieinfo_dir;
		movieinfo_dir  = (char *)calloc(250, sizeof(char));
		sprintf(movieinfo_dir, "%s/info/%s", main_dir, (char *)gtk_entry_get_text(GTK_ENTRY(newmovie_entry)));


		if(!access(movieinfo_dir,0)){
			GtkWidget *dialog;
				dialog = gtk_message_dialog_new(GTK_WINDOW(main_window),
				            GTK_DIALOG_DESTROY_WITH_PARENT,
				            GTK_MESSAGE_QUESTION,
				            GTK_BUTTONS_YES_NO,
				            "Bu film bilgileri zaten mevcut.\nBu bilgiler silinerek tekrardan indirilsin mi?");

				gtk_window_set_title(GTK_WINDOW(dialog), "Uyarı");
				if(gtk_dialog_run(GTK_DIALOG(dialog))== GTK_RESPONSE_YES){
					call_remove_info(NULL, (gpointer)gtk_entry_get_text(GTK_ENTRY(newmovie_entry)));
					gtk_widget_destroy(GTK_WIDGET(dialog));
				}
				else{
					free(movieinfo_dir);
					gtk_widget_destroy(GTK_WIDGET(dialog));
					gtk_widget_destroy(GTK_WIDGET(newmovie_dialog));
					return;
				}


		}
		free(movieinfo_dir);
	//	n = 1;
		if(listed == 0){
			movie_namelist = (char **)calloc(2, sizeof(char *));
			movie_namelist[1] = (char *)calloc(100, sizeof(char));
		}
		strcpy(movie_namelist[1], (char *)gtk_entry_get_text(GTK_ENTRY(newmovie_entry)));
		gtk_widget_destroy(GTK_WIDGET(newmovie_dialog));
		call_moviesearch(NULL, movie_namelist[1]);
	}
	else
		gtk_widget_destroy(GTK_WIDGET(newmovie_dialog));

}

/*****************************************************************/

static void call_rename_movie(GtkMenuItem *item, gpointer movie_name)
{
    GtkDialog *changename_dialog;
    GtkWidget *newname_entry, *label;


    changename_dialog = gtk_dialog_new_with_buttons(
			"İsim Değiştirme",
			GTK_WINDOW(main_window),
			GTK_DIALOG_DESTROY_WITH_PARENT,
			"Vazgeç",
			GTK_RESPONSE_REJECT,
			"Değiştir",
			GTK_RESPONSE_ACCEPT,
			NULL);

    gtk_window_set_default_size(GTK_WINDOW(changename_dialog), 250, 100);

    label = gtk_label_new("Eski İsim");
    gtk_box_pack_start(GTK_BOX(changename_dialog -> vbox), label, FALSE, FALSE, 0);

    newname_entry = gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(changename_dialog ->vbox), newname_entry, FALSE, FALSE, 10);
    gtk_entry_set_max_length (GTK_ENTRY(newname_entry), 100);

    gtk_widget_show_all(GTK_WIDGET(changename_dialog));

    if((gtk_dialog_run(changename_dialog)) == GTK_RESPONSE_ACCEPT)
            rename_movie(get_movieno((char*) movie_name), (char *)gtk_entry_get_text(GTK_ENTRY(newname_entry)));

    gtk_widget_destroy(GTK_WIDGET(changename_dialog));
    fill_movielist_properties(NULL, NULL);

}
/*****************************************************************/

static void call_delete_movie(GtkMenuItem *item, gpointer movie_name)
{
    GtkWidget *dialog;
    dialog = gtk_message_dialog_new(GTK_WINDOW(main_window),
	            GTK_DIALOG_DESTROY_WITH_PARENT,
	            GTK_MESSAGE_QUESTION,
	            GTK_BUTTONS_YES_NO,
	            "Filmi silinecek. Devam edilsin mi?");

    gtk_window_set_title(GTK_WINDOW(dialog), "Uyarı");

    if(gtk_dialog_run(GTK_DIALOG(dialog))== GTK_RESPONSE_YES)
        delete_movie(get_movieno((char*) movie_name));

    gtk_widget_destroy(GTK_WIDGET(dialog));
    fill_movielist_properties(NULL, NULL);
}

/*****************************************************************/

static void update_info(GtkMenuItem *item, gpointer movie_name)
{
    GtkWidget *dialog;
    dialog =gtk_message_dialog_new(GTK_WINDOW(main_window),
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_QUESTION,
            GTK_BUTTONS_YES_NO,
            "Film bilgileri üzerine yazılacak. Devam edilsin mi?");

    gtk_window_set_title(GTK_WINDOW(dialog), "Uyarı");

    if(gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_YES) {
    	char command[250];
    	sprintf(command, "/usr/share/mlm/dialog/mlm_show_dialog \"%s Filmi Güncelleniyor...\n\n    LÜTFEN BEKKLEYİN!!!\"&", (char *)movie_name);
    	system(command);

    	remove_movieinfo((char *)(movie_name));
        gtk_widget_destroy(GTK_WIDGET(dialog));

    	if(moviesearch((char *)movie_name))
    	    fprint_movieinf(get_movieno((char*) movie_name));

      fill_movielist_properties(NULL, NULL);
        kill_process();
    }
    else
        gtk_widget_destroy(GTK_WIDGET(dialog));

}

/*****************************************************************/

static void search_with_difname(GtkMenuItem *item, gpointer movie_name)
{
    char *movieinfo_dir, *difname_info_dir;

    movieinfo_dir  = (char *)calloc(250, sizeof(char));
    sprintf(movieinfo_dir, "%s/info/%s", main_dir, (char *)movie_name);

    if(!access(movieinfo_dir,0)) {

        GtkWidget *dialog;
        dialog =gtk_message_dialog_new(GTK_WINDOW(main_window),
                GTK_DIALOG_DESTROY_WITH_PARENT,
                GTK_MESSAGE_QUESTION,
                GTK_BUTTONS_YES_NO,
                "Film bilgileri zaten mevcut. Bu bilgiler silinerek yeniden indirilsin mi");

        gtk_window_set_title(GTK_WINDOW(dialog), "Uyarı");

        if(gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_NO) {
            free(movieinfo_dir);
            gtk_widget_destroy(GTK_WIDGET(dialog));
            return;
        }
        gtk_widget_destroy(GTK_WIDGET(dialog));
    }

    GtkDialog *newmovie_dialog;
    GtkWidget *newmovie_entry, *label;

    newmovie_dialog = gtk_dialog_new_with_buttons(
                    "Yeni Film Bilgisi İndirme",
                    GTK_WINDOW(main_window),
                    GTK_DIALOG_DESTROY_WITH_PARENT,
                    "Vazgeç",
                    GTK_RESPONSE_REJECT,
                    "İndir",
                    GTK_RESPONSE_ACCEPT,
                    NULL);

    gtk_window_set_default_size(GTK_WINDOW(newmovie_dialog), 300, 150);

    label = gtk_label_new("Bilgileri İndirilecek Filmin Adı");
    gtk_box_pack_start(GTK_BOX(newmovie_dialog -> vbox), label, FALSE, FALSE, 0);

    newmovie_entry = gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(newmovie_dialog ->vbox), newmovie_entry, FALSE, FALSE, 10);
    gtk_entry_set_max_length (GTK_ENTRY(newmovie_entry), 100);

    gtk_widget_show_all(GTK_WIDGET(newmovie_dialog));

    if((gtk_dialog_run(newmovie_dialog)) == GTK_RESPONSE_ACCEPT) {
        char *movieinfo_dir;
        movieinfo_dir  = (char *)calloc(250, sizeof(char));
        sprintf(movieinfo_dir, "%s/info/%s", main_dir, (char *)gtk_entry_get_text(GTK_ENTRY(newmovie_entry)));


        if(!access(movieinfo_dir,0)) {
            GtkWidget *dialog;
            dialog = gtk_message_dialog_new(GTK_WINDOW(main_window),
                                    GTK_DIALOG_DESTROY_WITH_PARENT,
                                    GTK_MESSAGE_QUESTION,
                                    GTK_BUTTONS_YES_NO,
                                    "Bu film bilgileri zaten mevcut.\nBu bilgiler silinerek tekrardan indirilsin mi?");

            gtk_window_set_title(GTK_WINDOW(dialog), "Uyarı");

            if(gtk_dialog_run(GTK_DIALOG(dialog))== GTK_RESPONSE_YES) {
                call_remove_info(NULL, (gpointer)gtk_entry_get_text(GTK_ENTRY(newmovie_entry)));
                gtk_widget_destroy(GTK_WIDGET(dialog));
            }
            else {
                free(movieinfo_dir);
                gtk_widget_destroy(GTK_WIDGET(dialog));
                gtk_widget_destroy(GTK_WIDGET(newmovie_dialog));
                return;

            }
        }

        //n = 1;
        strcpy(movie_namelist[1], (char *)gtk_entry_get_text(GTK_ENTRY(newmovie_entry)));

        call_moviesearch(NULL, movie_namelist[1]);

        difname_info_dir  = (char *)calloc(250, sizeof(char));
        sprintf(movieinfo_dir, "%s/info/%s", main_dir, (char *)movie_name);
        sprintf(difname_info_dir, "%s/info/%s", main_dir, (char *)gtk_entry_get_text(GTK_ENTRY(newmovie_entry)));

        remove_movieinfo((char *)(movie_name));
        if((rename(difname_info_dir, movieinfo_dir)) == -1) {
            perror("rename");
            fprintf(stdout, "%d\n", errno);
        }
        free(movieinfo_dir);
        free(difname_info_dir);
        gtk_widget_destroy(GTK_WIDGET(newmovie_dialog));
        fill_movielist_properties(NULL, NULL);

    }
    else
        gtk_widget_destroy(GTK_WIDGET(newmovie_dialog));

}

/*****************************************************************/

static void call_remove_info(GtkMenuItem *item, gpointer movie_name)
{
    GtkWidget *dialog;
    dialog =gtk_message_dialog_new(GTK_WINDOW(main_window),
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_QUESTION,
            GTK_BUTTONS_YES_NO,
            "Film bilgilerini silinecek. Devam edilsin mi?");

    gtk_window_set_title(GTK_WINDOW(dialog), "Uyarı");

    if(gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_YES) {
    	remove_movieinfo((char *)(movie_name));
        fill_movielist_properties(NULL, NULL);
    }
    gtk_widget_destroy(GTK_WIDGET(dialog));
}

/*****************************************************************/

gboolean addmenu_to_treeview(GtkWidget *wi, GdkEventButton *ev, gpointer user_data)
{
    GtkTreeModel *model;
    GtkTreePath *path;
    GtkTreeIter iter;
    GtkWidget *menu;
    GtkWidget *menuitem;
    GtkTextBuffer *movie_sum_buffer, *movie_sum_buffer2;

    char *movie_name, *movieinfo_dir;

    if(! (path = gtk_icon_view_get_path_at_pos(GTK_ICON_VIEW(wi), ev->x, ev->y)))
        return FALSE;

    model = gtk_icon_view_get_model(GTK_ICON_VIEW(wi));
    gtk_tree_model_get_iter(model, &iter, path);
    gtk_tree_model_get(model, &iter, 0, &movie_name, -1);

    movieinfo_dir  = (char *)calloc(250, sizeof(char));
    sprintf(movieinfo_dir, "%s/info/%s", main_dir, movie_name);

    switch(ev->button)
    {
    case 3:
    	model = gtk_icon_view_get_model(GTK_ICON_VIEW(wi));
    	gtk_tree_model_get_iter(model, &iter, path);
    	gtk_tree_model_get(model, &iter, 0, &movie_name, -1);
        menu = gtk_menu_new();

    	if(!access(movieinfo_dir,0)) {

            menuitem = gtk_menu_item_new_with_label("Filmi Aç");
             g_signal_connect (menuitem, "activate", G_CALLBACK(open_moviepath), movie_name);
             gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
            gtk_widget_show(menuitem);

            menuitem = gtk_menu_item_new_with_label("Bilgileri Güncelle");
            g_signal_connect (menuitem, "activate", G_CALLBACK (update_info), movie_name);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
            gtk_widget_show(menuitem);

            menuitem = gtk_menu_item_new_with_label("Bilgileri Sil");
            g_signal_connect (menuitem, "activate", G_CALLBACK (call_remove_info), movie_name);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
            gtk_widget_show(menuitem);
    	}
    	else {
            menuitem = gtk_menu_item_new_with_label("Bilgileri İndir");
            g_signal_connect (menuitem, "activate", G_CALLBACK (call_moviesearch), (char *)movie_name);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
            gtk_widget_show(menuitem);
    	}

        menuitem = gtk_menu_item_new_with_label("İsmi Değiştir");
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
        g_signal_connect (menuitem, "activate", G_CALLBACK (call_rename_movie), movie_name);
        gtk_widget_show(menuitem);

        menuitem = gtk_menu_item_new_with_label("Filmi ve Bilgileri Sil");
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
        g_signal_connect (menuitem, "activate", G_CALLBACK (call_delete_movie), movie_name);
        gtk_widget_show(menuitem);

        menuitem = gtk_menu_item_new_with_label("Farklı isimle ara");
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
        g_signal_connect (menuitem, "activate", G_CALLBACK (search_with_difname), movie_name);
        gtk_widget_show(menuitem);

        gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, 3, ev->time);

        //break yok. Sağ tıklamadan sonra bilgiler gösterilsin diye sol tık olayına devam ediliyor.
    case 1:
        if(!access(movieinfo_dir,0)) {
            char *movie_sum;
            char movie_info_poster[2][200];
            char *labels_text;
            char *temp;

            labels_text = (char *)calloc(250, sizeof(char));

            scan_save_movieinfo_dir(movie_info_poster, movieinfo_dir);

            movie_sum_buffer = gtk_text_buffer_new(NULL);
            movie_sum = read_all_file(movieinfo_dir);

            //movie name
            sprintf(labels_text, "Filmin Adı: %s", movie_name);
            char *markup = g_markup_printf_escaped("<span weight=\"bold\">%s</span>", labels_text);
            gtk_label_set_text(GTK_LABEL(label_name), "");
            gtk_label_set_markup(GTK_LABEL(label_name), markup);


            ///Movie point sinemalar.com
            temp = strstr_dup(movie_sum, "[+mlm_puan]", "[-mlm_puan]");
            sprintf(labels_text, "\nSinemalar.com Puanı: %s", temp);
            gtk_label_set_text(GTK_LABEL(point_label), labels_text);
            free(temp);

           //Movie point sinemalar.imdb
            temp = strstr_dup(movie_sum, "[+mlm_IMDB]", "[-mlm_IMDB]");
            sprintf(labels_text, "IMDB Puanı: %s\n", temp);
            gtk_label_set_text(GTK_LABEL(imdb_point), labels_text);
            free(temp);

            //Movie year
            temp = strstr_dup(movie_sum, "[+mlm_Yer]", "[-mlm_Yer]");
            sprintf(labels_text, "Yapım Yeri: %s", temp);
            gtk_label_set_text(GTK_LABEL(label_place), labels_text);
            free(temp);

            //Movie place
            temp = strstr_dup(movie_sum, "[+mlm_Yıl]", "[-mlm_Yıl]");
            sprintf(labels_text, "Yapım Yılı: %s", temp);
            gtk_label_set_text(GTK_LABEL(label_year), labels_text);
            free(temp);

            //Movie type
            temp = strstr_dup(movie_sum, "[+mlm_Tur]", "[-mlm_Tur]");
            sprintf(labels_text, "Tür: %s", temp);
            gtk_label_set_text(GTK_LABEL(label_type), labels_text);
            free(temp);

            //Movie director
            temp = strstr_dup(movie_sum, "[+mlm_Yonetmen]", "[-mlm_Yonetmen]");
            sprintf(labels_text, "Yönetmen: %s", temp);
            gtk_label_set_text(GTK_LABEL(label_director), labels_text);
            free(temp);

            //Movie cast
            temp = strstr_dup(movie_sum, "[+mlm_Oyuncular]\n", "[-mlm_Oyuncular]");
            gtk_text_buffer_set_text(movie_sum_buffer, temp, -1);
            gtk_text_view_set_buffer(GTK_TEXT_VIEW(show_movie_sum),  movie_sum_buffer);

            //Movie Sum
            movie_sum_buffer2 = gtk_text_buffer_new(NULL);
            temp = strstr_dup(movie_sum, "[+mlm_Filmin özeti]\n", "[-mlm_Filmin özeti]");
            gtk_text_buffer_set_text(movie_sum_buffer2, temp, -1);
            gtk_text_view_set_buffer(GTK_TEXT_VIEW(show_movie_cast),  movie_sum_buffer2);

            free(movie_sum);
            free(labels_text);
        }
        else {
            movie_sum_buffer = gtk_text_buffer_new(NULL);
            gtk_text_buffer_set_text(movie_sum_buffer, "Oyuncular Bulunamadi", 20);   //Bilgi Yok
            gtk_text_view_set_buffer(GTK_TEXT_VIEW(show_movie_sum),  movie_sum_buffer);

            movie_sum_buffer2 = gtk_text_buffer_new(NULL);
            gtk_text_buffer_set_text(movie_sum_buffer2, "Özet Bulunamadi", 16);   //Özet Yok
            gtk_text_view_set_buffer(GTK_TEXT_VIEW(show_movie_cast),  movie_sum_buffer2);

            char *labels_text;

            labels_text = (char *)calloc(250, sizeof(char));

            //movie name
            sprintf(labels_text, "Filmin Adı: %s", movie_name);

            char *markup = g_markup_printf_escaped("<span weight=\"bold\">%s</span>", labels_text);
            gtk_label_set_text(GTK_LABEL(label_name), "");
            gtk_label_set_markup(GTK_LABEL(label_name), markup);
            g_free(markup);

            ///Movie point sinemalar.com
            gtk_label_set_text(GTK_LABEL(point_label), "\nSinemalar.com Puanı: -");

           //Movie point sinemalar.imdb
            gtk_label_set_text(GTK_LABEL(imdb_point), "IMDB Puanı: -\n");

            //Movie year
            gtk_label_set_text(GTK_LABEL(label_place), "Yapım Yeri: -");

            //Movie place
            gtk_label_set_text(GTK_LABEL(label_year), "Yapım Yılı: -");

            //Movie type
            gtk_label_set_text(GTK_LABEL(label_type), "Tür: -");

            //Movie director
            gtk_label_set_text(GTK_LABEL(label_director), "Yönetmen: -");
        }

        gtk_tree_path_free(path);
        free(movieinfo_dir);

        break;
    }

    return FALSE;
}

/*****************************************************************/

static void fill_movielist_properties( GtkWidget *widget,  gpointer   data )
{
    ///////////////Son Dizin Saklama İşlemi/////////////////
    FILE *conf1;
    char *conf_dir;

    conf_dir = (char *)calloc(60, sizeof(char));
    sprintf(conf_dir, "%s/conf/conf1", main_dir);
    if(widget != NULL){
    	if(!strcmp(((char *)gtk_button_get_label(GTK_BUTTON(widget))), "İndirilmiş tüm bilgileri göster"))
    		sprintf(moviespath, "/home/%s/.movielist manager/info", username);
    	else
    		strcpy(moviespath, gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER(file_chooser)));
    }

    if (scan_files() == -1) {
        GtkWidget *dialog;

        dialog = gtk_message_dialog_new(GTK_WINDOW(main_window),
                    GTK_DIALOG_DESTROY_WITH_PARENT,
                    GTK_MESSAGE_ERROR,
                    GTK_BUTTONS_OK,
                    "%s\n\nDizin Bulunamadı!", moviespath);

        gtk_window_set_title(GTK_WINDOW(dialog), "HATA");

        gtk_dialog_run(GTK_DIALOG(dialog));

        gtk_widget_destroy(dialog);

        return;
    }

    //if directory empty, ignore . and .. files
    if(n == 2)
        n = 0;

    //struct dirent ** yapısı bırakılıp isimler diziye aktarılıyor...
    save_movieslist();

    if(widget != NULL){
    	if(strcmp(((char *)gtk_button_get_label(GTK_BUTTON(widget))), "İndirilmiş tüm bilgileri göster")){
    		 listed = 1;
    	     if((conf1 = fopen(conf_dir, "w")) == NULL)
    	     	fprintf(stdout, "%s dosyası açılamadı, son dizin kayıt edilemeyecek", conf_dir);
    	     else {
    	     	fprintf(conf1, "%s\n", moviespath);
    	     	fclose(conf1);
    	     }
    	     gtk_widget_set_sensitive(GTK_WIDGET(show_other_infos),TRUE);
    	}
    }
        free(conf_dir);


        ///////////////Filmleri İkon Olarak Gösterme İşlemi/////////////////
    GtkListStore *list_store;
    GError **error = NULL;
    GdkPixbuf *movielist_icon;
    GtkTreeIter iter;
    int i = 1;
    char movie_info_poster[2][200];
    char *movieinfo_dir;

    movieinfo_dir = (char *)calloc(250, sizeof(char));

    list_store = gtk_list_store_new(NUM_COLS, G_TYPE_STRING, GDK_TYPE_PIXBUF);

    for (; i <= (n - 2); ++i) {
        sprintf(movieinfo_dir, "%s/info/%s", main_dir, movie_namelist[i]);

    	if(!access(movieinfo_dir,0)){
            scan_save_movieinfo_dir(movie_info_poster, movieinfo_dir);

            if(!(access(movie_info_poster[1], 0)))
                movielist_icon =  gdk_pixbuf_new_from_file(movie_info_poster[1], error);
            else
                movielist_icon = gdk_pixbuf_new_from_file(ICON_PATH,error);
        }
    	else
            movielist_icon = gdk_pixbuf_new_from_file(ICON_PATH, error);

        gtk_list_store_append(list_store, &iter);
        gtk_list_store_set(list_store, &iter, COL_DISPLAY_NAME, movie_namelist[i], COL_PIXBUF, movielist_icon, -1);

        g_object_unref(movielist_icon);
    }

    free(movieinfo_dir);

    gtk_icon_view_set_model(GTK_ICON_VIEW(movies_icon_list), GTK_TREE_MODEL(list_store));
    gtk_widget_set_sensitive(GTK_WIDGET(search_entry),TRUE);
    gtk_widget_show_all(main_window);

    g_object_unref(list_store);
}

/*****************************************************************/

static void search_for_fill_movielist_properties( GtkWidget *widget,  gpointer   data )
{
    GtkListStore *list_store;
    GError **error = NULL;
    GdkPixbuf *movielist_icon;
    GtkTreeIter iter;
    int i = 1;
    char movie_info_poster[2][200];
    char *movieinfo_dir;

    movieinfo_dir  = (char *)calloc(250, sizeof(char));

    list_store = gtk_list_store_new(NUM_COLS, G_TYPE_STRING, GDK_TYPE_PIXBUF);

    key = (char *)gtk_entry_get_text(GTK_ENTRY(search_entry));

    for (; i <= n-1; ++i) {
        if(compare_wh_case(movie_namelist[i], key)){
            sprintf(movieinfo_dir, "%s/info/%s", main_dir, movie_namelist[i]);

            if(!access(movieinfo_dir,0)) {
                scan_save_movieinfo_dir(movie_info_poster, movieinfo_dir);

                if(!(access(movie_info_poster[1], 0)))
                    movielist_icon =  gdk_pixbuf_new_from_file(movie_info_poster[1],error);
                else
                    movielist_icon =   gdk_pixbuf_new_from_file(ICON_PATH, error);

            }
            else
                movielist_icon =   gdk_pixbuf_new_from_file(ICON_PATH, error);

    		gtk_list_store_append(list_store, &iter);
    		gtk_list_store_set(list_store, &iter, COL_DISPLAY_NAME, movie_namelist[i], COL_PIXBUF, movielist_icon, -1);
    		g_object_unref(movielist_icon);
    	}
    }

    free(movieinfo_dir);

    gtk_icon_view_set_model(GTK_ICON_VIEW(movies_icon_list), GTK_TREE_MODEL(list_store));

    gtk_widget_show_all(main_window);

    g_object_unref(list_store);
}

/*****************************************************************/

static void show_others( GtkWidget *widget,  gpointer   data )
{
    gtk_widget_set_sensitive(GTK_WIDGET(show_other_infos),FALSE);
    char *main_info_dir;
    int j;
    char other_movies[200][100];

    main_info_dir  = (char *)calloc(60, sizeof(char));
    sprintf(main_info_dir, "%s/info", main_dir);
    strcpy(moviespath, main_info_dir);
    compare_moviespath_maininfodir_files(main_info_dir, other_movies);


    if(n == 2){
        gtk_widget_set_sensitive(GTK_WIDGET(show_other_infos),FALSE);
        return;
    }

    GtkListStore *list_store;
    GdkPixbuf *movielist_icon;
    GError **error = NULL;
    GtkTreeIter iter;
    char movie_info_poster[2][200];
    char *movieinfo_dir;

    movieinfo_dir  = (char *)calloc(250, sizeof(char));

    list_store = gtk_list_store_new(NUM_COLS, G_TYPE_STRING, GDK_TYPE_PIXBUF);

    for (j = 1; j <= n-1; ++j) {

        sprintf(movieinfo_dir, "%s/info/%s", main_dir, other_movies[j]);

        if(!access(movieinfo_dir,0)) {
            scan_save_movieinfo_dir(movie_info_poster, movieinfo_dir);

            if(!(access(movie_info_poster[1], 0)))
                movielist_icon = gdk_pixbuf_new_from_file(movie_info_poster[1], error);
            else
                movielist_icon =   gdk_pixbuf_new_from_file(ICON_PATH, error);

        }
        else
            movielist_icon =   gdk_pixbuf_new_from_file(ICON_PATH, error);

        gtk_list_store_append(list_store, &iter);
        gtk_list_store_set(list_store, &iter, COL_DISPLAY_NAME, other_movies[j], COL_PIXBUF, movielist_icon, -1);
        g_object_unref(movielist_icon);
    }

    free(movieinfo_dir);

    gtk_icon_view_set_model(GTK_ICON_VIEW(movies_icon_list), GTK_TREE_MODEL(list_store));

    gtk_widget_show_all(main_window);

    g_object_unref(list_store);
    free(main_info_dir);
}

/*****************************************************************/

void destroy( GtkWidget *widget, gpointer   data )
{
    g_print("Kapatılıyor...\n");
    gtk_main_quit ();
}

/*****************************************************************/

static void change_expander_label(GtkWidget *widget, gpointer data)
{
	if(strcmp(((char *)gtk_expander_get_label(GTK_EXPANDER(widget))), "Arama Menüsünü Aç"))
		gtk_expander_set_label(GTK_EXPANDER(widget), "Arama Menüsünü Aç");
	else
		gtk_expander_set_label(GTK_EXPANDER(widget), "Arama Menüsünü Kapat");
}

/*****************************************************************/

static void change_expander2_label(GtkWidget *widget, gpointer data)
{
	if(strcmp(((char *)gtk_expander_get_label(GTK_EXPANDER(widget))), "Arşiv Dizinini Gizle"))
		gtk_expander_set_label(GTK_EXPANDER(widget), "Arşiv Dizinini Gizle");
	else
		gtk_expander_set_label(GTK_EXPANDER(widget), "Arşiv Dizinini Göster");
}

/*****************************************************************/

void create_main_window(void)
{
	kill_process();
    GtkWidget *vbox1, *list_button, *separator, *hbox2, *label, *hbox3, *button, *expander, *vbox3, *expander2;

    //Ana pencere oluşturulup, ayarlanıyor
    main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW (main_window), "MovieList Manager");
    gtk_window_set_position(GTK_WINDOW(main_window), GTK_WIN_POS_CENTER);
    gtk_container_set_border_width(GTK_CONTAINER(main_window), 15);
    gtk_widget_set_size_request(main_window, 900, 600);
    g_signal_connect (main_window, "destroy",  G_CALLBACK (destroy), NULL);

    //Program Logosu
    char *LOGO;
    LOGO = (char *)calloc(100, sizeof(char));
    strcpy(LOGO, "/usr/share/mlm/images/mlm_logo.png");
	GdkPixbuf *Logo;
	GError *err = NULL;
	Logo = gdk_pixbuf_new_from_file(LOGO, &err);
    gtk_window_set_icon(GTK_WINDOW(main_window), GDK_PIXBUF(Logo));
    free(LOGO);

    hpaned = gtk_hpaned_new();
    gtk_widget_set_size_request (hpaned, 150, 150);
    gtk_container_add(GTK_CONTAINER(main_window), hpaned);

    main_hbox = gtk_hbox_new(FALSE, 0);
    gtk_paned_add1(GTK_PANED (hpaned), main_hbox);

    vbox1 = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(main_hbox), vbox1);

    expander2 = gtk_expander_new("Arşiv Dizinini Gizle");
    g_signal_connect(G_OBJECT(expander2), "activate", G_CALLBACK(change_expander2_label), NULL);
    gtk_box_pack_start(GTK_BOX(vbox1), expander2, FALSE ,FALSE, 0);
    gtk_expander_set_expanded (GTK_EXPANDER(expander2), TRUE);

    hbox3 = gtk_hbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(expander2), hbox3);

    file_chooser = gtk_file_chooser_button_new("Film Arşivi Dizinini Seçin", GTK_FILE_CHOOSER_ACTION_OPEN | GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
    gtk_box_pack_start(GTK_BOX(hbox3), file_chooser,TRUE, TRUE, 0);

    list_button = gtk_button_new_with_label("Listele");
    gtk_box_pack_start(GTK_BOX(hbox3), list_button, FALSE, FALSE, 0);
    g_signal_connect (list_button, "clicked",  G_CALLBACK (fill_movielist_properties), NULL);

    separator = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(vbox1), separator, FALSE, FALSE, 5);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);

    char *markup = g_markup_printf_escaped("<span weight=\"bold\">%s</span>", "Filmin Adı:");
    label_name = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label_name), markup);
    gtk_box_pack_start(GTK_BOX(hbox2), label_name, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);

    label_year = gtk_label_new("Yapım Yılı:");
    gtk_box_pack_start(GTK_BOX(hbox2), label_year, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);

    label_place = gtk_label_new("Yapım Yeri:");
    gtk_box_pack_start(GTK_BOX(hbox2), label_place, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);

    label_type = gtk_label_new("Tür:");
    gtk_box_pack_start(GTK_BOX(hbox2), label_type, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);

    label_director = gtk_label_new("Yönetmen:");
    gtk_box_pack_start(GTK_BOX(hbox2), label_director, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);

    point_label = gtk_label_new("\nSinemalar.com Puanı:");
    gtk_box_pack_start(GTK_BOX(hbox2), point_label, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);

    imdb_point = gtk_label_new("IMDB Puanı:\n");
    gtk_box_pack_start(GTK_BOX(hbox2), imdb_point, FALSE, FALSE, 0);

    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 0);


    markup = g_markup_printf_escaped("<span weight=\"bold\" style=\"italic\">%s</span>", "Oyuncular");
    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label), markup);
    gtk_box_pack_start(GTK_BOX(vbox1), label, FALSE, FALSE, 0);

    sw_textview = gtk_scrolled_window_new(NULL, NULL);
    gtk_box_pack_start(GTK_BOX(vbox1), sw_textview, FALSE, FALSE, 5);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw_textview), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw_textview), GTK_SHADOW_IN);

    show_movie_sum = gtk_text_view_new();
    gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW(show_movie_sum), GTK_WRAP_WORD);
    gtk_container_add(GTK_CONTAINER(sw_textview), show_movie_sum);

    markup = g_markup_printf_escaped("<span weight=\"bold\" style=\"italic\">%s</span>", "Özet");
    label = gtk_label_new(" ");
    gtk_label_set_markup(GTK_LABEL(label), markup);
    gtk_box_pack_start(GTK_BOX(vbox1), label, FALSE, FALSE, 5);

    sw_textview = gtk_scrolled_window_new(NULL, NULL);
    gtk_box_pack_start(GTK_BOX(vbox1), sw_textview, TRUE, TRUE, 0);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw_textview), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw_textview), GTK_SHADOW_IN);

    show_movie_cast = gtk_text_view_new();
    gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW(show_movie_cast), GTK_WRAP_WORD);
    gtk_container_add(GTK_CONTAINER(sw_textview), show_movie_cast);

    vbox2 = gtk_vbox_new(TRUE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), vbox2, FALSE, FALSE, 0);

    vbox2 = gtk_vbox_new(FALSE, 0);
    gtk_paned_add2(GTK_PANED (hpaned), vbox2);

    //////////////////////////////////////Search Menu//////////////////////////////////////
    expander = gtk_expander_new("Arama Menüsünü Aç");
    g_signal_connect(G_OBJECT(expander), "activate", G_CALLBACK(change_expander_label), NULL);
    gtk_box_pack_start(GTK_BOX(vbox2), expander, FALSE, FALSE, 0);

    vbox3 = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(expander), vbox3);

    hbox2 = gtk_hbox_new(FALSE, 0 );
    gtk_box_pack_start(GTK_BOX(vbox3), hbox2, FALSE, FALSE, 0);

    //search with key in last listed dir
    label = gtk_label_new("Arama:   ");
    gtk_box_pack_start(GTK_BOX(hbox2), label, FALSE, FALSE, 0);

    search_entry = gtk_entry_new();
    g_signal_connect(G_OBJECT(search_entry), "key_release_event", G_CALLBACK (search_for_fill_movielist_properties), NULL);
    gtk_box_pack_start(GTK_BOX(hbox2), search_entry, TRUE, TRUE, 0);
    gtk_entry_set_max_length (GTK_ENTRY(search_entry), 30);
    gtk_widget_set_sensitive(GTK_WIDGET(search_entry),FALSE);
    key = (char *)calloc(30, sizeof(char)); // for get search_entry

    //search infos which other dirs include movie's
    show_other_infos = gtk_button_new_with_label("Bu dizin haricinde, kayıtlı bilgileri göster");
    g_signal_connect(G_OBJECT(show_other_infos), "clicked", G_CALLBACK(show_others), NULL);
    gtk_box_pack_start(GTK_BOX(vbox3), show_other_infos, FALSE , FALSE, 0);
    gtk_widget_set_sensitive(GTK_WIDGET(show_other_infos),FALSE);

    //Search a movie in sinemalar.com
    button = gtk_button_new_with_label("Kayıtlı olmayan film bilgilerini ara");
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(get_new_movieinfo), NULL);
    gtk_box_pack_start(GTK_BOX(vbox3), button, FALSE , FALSE, 0);

    //Show All infos
    show_all = gtk_button_new_with_label("İndirilmiş tüm bilgileri göster");
    g_signal_connect(G_OBJECT(show_all), "clicked", G_CALLBACK(fill_movielist_properties), NULL);
    gtk_box_pack_start(GTK_BOX(vbox3), show_all, FALSE, FALSE, 0);


    movies_list =  gtk_scrolled_window_new(NULL, NULL);
    gtk_box_pack_start(GTK_BOX(vbox2), movies_list, TRUE ,TRUE, 5);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(movies_list), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(movies_list), GTK_SHADOW_IN);
    gtk_widget_set_size_request (movies_list, 50, -1);

    movies_icon_list = gtk_icon_view_new();
    g_signal_connect(movies_icon_list, "button-press-event", G_CALLBACK(addmenu_to_treeview), NULL);
    gtk_icon_view_set_text_column(GTK_ICON_VIEW(movies_icon_list), COL_DISPLAY_NAME);
    gtk_icon_view_set_pixbuf_column(GTK_ICON_VIEW(movies_icon_list), COL_PIXBUF);
    gtk_icon_view_set_row_spacing (GTK_ICON_VIEW(movies_icon_list), 0);
    gtk_icon_view_set_column_spacing (GTK_ICON_VIEW(movies_icon_list), 0);
    gtk_icon_view_set_item_width(GTK_ICON_VIEW(movies_icon_list), 100);

    gtk_container_add(GTK_CONTAINER(movies_list), movies_icon_list);

    gtk_widget_show_all(main_window);
}

/*****************************************************************/

void set_filechooser(void)
{
    //Önceden girilmiş dizin yoksa ya da dizin bulunamazsa varsayılan olarak ev dizini aç.
    if(access(moviespath, 0)){
        char userhome[50];
        sprintf(userhome, "/home/%s", username);
         gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(file_chooser), userhome);
    }
    else
        gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(file_chooser), moviespath);
}

/*****************************************************************/

void open_moviepath(GtkMenuItem *item, char *moviename)
{

     char command[250];

     if (!strstr(moviespath, ".movielist")) {
         sprintf(command, "xdg-open /'%s'/'%s'", moviespath, moviename);
         system(command);
     }
 }

