#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <signal.h>
#include <ctype.h>

#include "mlm_utility.h"
#include "mlm_string.h"
#include "mlm_file.h"

/*****************************************************************/


 char *movielist_str_edit(char *moviename)
{
    char *chr[4] = {"+", "_", ".", "\'"};
    int i;
    char *p;

    str_insert_all(moviename, ".avi", "");
    str_insert_all(moviename, ".mkv", "");
       
    for (i = 0; i < 4; i++)
        str_insert_all(moviename, chr[i], " ");

    str_insert_all(moviename, "  ", " ");

    str_insert_all(moviename, "   ", " ");

    str_remove(moviename, '(', ')');

    str_remove(moviename, '[', ']');

    if (moviename[0] == ' ')
    	str_insert(moviename, " ", "");

    if (p = strrchr(moviename, ' '))
        p = '\0';

    return moviename;
}

/*****************************************************************/
 void fprint_movieinf(int movieno)
{
    FILE *f, *movie_info;
    char *ptr, *p, *movie_info_path, *movie_info_dir;
    char buf[10000];
    char command[300];
    char moviename[100];
    int count = 10;

    if ((f = fopen(download_index_path, "r")) == NULL) {
        printf("Cannot open file:%s\n", download_index_path);
        exit(EXIT_FAILURE);
    }

    strcpy(moviename, get_moviename((movieno)));

    movie_info_dir  = calloc(200, sizeof(char));
    movie_info_path = calloc(200, sizeof(char));

    sprintf(movie_info_dir,"%s/info/%s", main_dir, moviename);
    sprintf(movie_info_path,"%s/info", movie_info_dir);

    if(mkdir(movie_info_dir, 0777) != 0) {
     printf("%s dizini oluşturulurken bir hata meydana geldi...\n", movie_info_dir);
     perror("fopen");
     exit(EXIT_FAILURE);
    }

    if((movie_info = fopen(movie_info_path,"w")) == NULL)
    {
    	fprintf(stdout,"Can not create file:%s\n", movie_info_path);
    	exit(EXIT_FAILURE);
    }




    //Filmin afisi
    while (fgets(buf, 1000, f))
        if (strstr(buf, "afisleri")) {
            fgets(buf, 1000, f);
            if (ptr = strstr_dup(buf, "src=\"", "\"")) {
                sprintf(command, "wget %s -P '%s'", ptr, movie_info_dir);
                system(command);
                free(ptr);
            }
        }


    //Sinemalar.com puani
    fprintf(movie_info,"[+mlm_puan]");
    rewind(f);
    ptr = NULL;
    while (fgets(buf, 1000, f))
        if (strstr(buf, "Sinemalar.com Puanı:")) {
            fgets(buf, 1000, f);
            if (ptr = strstr_dup(buf, "point\">", "</")) {
                fprintf(movie_info,"%s", ptr);
                free(ptr);
                break;
            }
        }
    if (!ptr)
        fprintf(movie_info,"Oy yok");
    fprintf(movie_info,"[-mlm_puan]\n");



    //IMDB.com puani
    fprintf(movie_info,"[+mlm_IMDB]");
    ptr = NULL;
    while (fgets(buf, 1000, f) && count--)
       if (strstr(buf, "imdb.com"))
           if (ptr = strstr_dup(buf, "\">", "<")) {
               fprintf(movie_info,"%s", ptr);
               free(ptr);
               break;
           }
    if (!ptr)
        fprintf(movie_info,"Oy yok");
    fprintf(movie_info,"[-mlm_IMDB]\n");
    count = 10;


 
    //Yapim yili
    fprintf(movie_info,"[+mlm_Yıl]");
    if (!ptr) {
        rewind(f);
        while (fgets(buf, 1000, f))
            if (strstr(buf, "Sinemalar.com Puanı:"))
                break;
    }
    while (fgets(buf, 1000, f))
       if (strstr(buf, "filmler/yil") && count--) {
           if (ptr = strstr_dup(buf, "\">", "<")) {
                fprintf(movie_info,"%s", ptr);
                free(ptr);
                break;
           }
       }
    if (!ptr)
        fprintf(movie_info," - ");
    fprintf(movie_info,"[-mlm_Yıl]\n");
    count = 10;



    //Yapim yeri
    fprintf(movie_info,"[+mlm_Yer]");
     if (!ptr) {
        rewind(f);
        while (fgets(buf, 1000, f))
            if (strstr(buf, "Sinemalar.com Puanı:"))
                break;
    }
    while (fgets(buf, 1000, f) && count--)
       if (strstr(buf, "filmler/ulke")) {
           if (ptr = strstr_dup(buf, "\">", "<")) {
               fprintf(movie_info,"%s", ptr);
               free(ptr);
               break;
           }
       }
    if (!ptr)
        fprintf(movie_info," - ");
    fprintf(movie_info,"[-mlm_Yer]\n");
    count = 10;



    //Türü (İlk 3 tanesi)
    fprintf(movie_info,"[+mlm_Tur]");
     fread(buf, 1, 2000, f);
     if (p = strstr(buf, "filmler/tur")) {
         if (ptr = strstr_dup(p, "\">", "<")) {
             fprintf(movie_info,"%s, ", ptr);
             free(ptr);
             p += 10;
         }

         if (p = strstr(p, "filmler/tur"))
              if (ptr = strstr_dup(p, "\">", "<")) {
                 fprintf(movie_info,"%s, ", ptr);
                 free(ptr);
                 p += 10;
              }

         if (p) {
             if (p = strstr(p, "filmler/tur"))
                  if (ptr = strstr_dup(p, "\">", "<")) {
                     fprintf(movie_info,"%s", ptr);
                     free(ptr);
                  }
         }
     }
     else
         fprintf(movie_info, "Yok");
     fprintf(movie_info, "[-mlm_Tur]\n");



     //Yönetmen
     fprintf(movie_info,"[+mlm_Yonetmen]");
     if (ptr = strstr(buf, "/sanatci")) {
         if (ptr = strstr_dup(ptr, "\">", "<")) {
             fprintf(movie_info,"%s", ptr);
             free(ptr);
         }
     }
     else
         fprintf(movie_info,"Yok", ptr);
     fprintf(movie_info,"[-mlm_Yonetmen]\n");



    //Filmin oyunculari
     fprintf(movie_info,"[+mlm_Oyuncular]\n");
     p = NULL;
     while (fgets(buf, 1000, f)){
       if ((ptr = strstr_dup(buf, "\"0\" title=\"", "\""))) {
           fprintf(movie_info,"%s\n", ptr);
           free(ptr);
           p = ptr;
         }
     }
     if (!p)
           fprintf(movie_info,"Oyuncu bulunamadı...\n");
     fprintf(movie_info,"[-mlm_Oyuncular]\n");



     
     //Filmin özeti
     fprintf(movie_info, "[+mlm_Filmin özeti]");
     rewind(f);
     ptr = NULL;
     while (fgets(buf, 1000, f))
         if (ptr = strstr(buf, "Filmin Özeti")) {
             fread(buf, 1, 10000, f);
             if (ptr = strstr_dup(buf, "content\">", "</div>")) {
                 f_printhtml(movie_info, ptr);
                 free(ptr);
                 break;
             }
         }
     if (!ptr)
        f_printhtml(movie_info, "Filmin özeti bulunamadı...\n");
     fprintf(movie_info, "[-mlm_Filmin özeti]");


    fclose(movie_info);
    fclose(f);
    free(movie_info_path);
    free(movie_info_dir);

}

/*****************************************************************/


 void print_movieinf_from_file(char *file_path)
{
	FILE *movie_info_file;
	char ch;

	if((movie_info_file = fopen(file_path, "r")) == NULL)
	{
		fprintf(stdout,"%s dosyası açılamadı\n", file_path);
		exit(EXIT_FAILURE);
	}

	for(;!feof(movie_info_file);){
		fscanf(movie_info_file, "%c", &ch);
		fprintf(stdout,"%c", ch);
	}
	getchar();
}

/*****************************************************************/

 void kill_process(void)
{
	FILE * PSAUX;
	char kullanici_adi[50];
	int PIDNO;
	PSAUX = popen("ps aux | grep mlm_show_dialog", "r");

	//Açık olan programın bilgilerini al
	fscanf(PSAUX, "%s%d", kullanici_adi, &PIDNO);
	pclose(PSAUX);

	//Açık olan programa SIGUSR1 sinyalini gönder
	kill(PIDNO, SIGUSR1);
}

